/*******************************************************************************************
Lab. Elettronica & Telecom - Controllo e decodifica dei pulsanti di un telecomando
a raggi infrarossi con relativa applicazione per un comando on off che attiva l'accensione
e lo spegnimento di un LED - Con il seguente sketch è possibile decodificare il codice in
esadecimale della tastiera di un generico telecomando IR - Materiale occorrente:
Arduino UNO,sensore IR TSOP1738(o equivalente), telecomando IR.
I codici rilevati vanno iseriti rispettivamente dopo i prefix 0x...... e dopo 0x10......
*********************************************************************************************/
#include <IRremote.h> // use the library
int receiver = 6; // pin Signal of IR receiver connect to Arduino digital pin 6
IRrecv irrecv(receiver); // create instance of 'irrecv'
decode_results results; // print in label results the code of button

void setup()
{
  Serial.begin(9600); // for serial monitor output
  irrecv.enableIRIn(); // Start the receiver
  pinMode(13,OUTPUT); // Pin 13 set output
  pinMode(12,OUTPUT); // Pin 12 set output
  pinMode(11,OUTPUT); // Pin 11 set output
  pinMode(9,OUTPUT); // Pin 9 set output
}
void loop()
{
  if (irrecv.decode(&results)) // have we received an IR signal?
  {
    Serial.println(results.value, HEX); // display it on serial monitor in hexadecimal
    irrecv.resume();// receive the next value
  }
  if ( results.value == 0x0FF30CF ||  results.value == 0x10FF30CF ) //tasto 1 sul telecomando
  { 
    digitalWrite(13, HIGH);   // set the LED ON
  } 
 if ( results.value == 0xFF10EF ||  results.value == 0x10FF10EF ) //tasto 4 sul telecomando
  { 
    digitalWrite(13, LOW);   // set the LED 0FF
}
  if ( results.value == 0x0FF18E7 ||  results.value == 0x10FF18E7 ) //tasto 2 sul telecomando
  { 
    digitalWrite(12, HIGH);   // set the LED ON
  } 
  if ( results.value == 0xFF38C7 ||  results.value == 0x10FF38C7 ) //tasto 5 sul telecomando
  { 
    digitalWrite(12, LOW);   // set the LED 0FF
  }
 
  if ( results.value == 0x0FF7A85 ||  results.value == 0x10FF7A85 ) //tasto 3 sul telecomando
  { 
    digitalWrite(11, HIGH);   // set the LED ON
  } 
  if ( results.value == 0x0FF5AA5 ||  results.value == 0x10FF5AA5 ) //tasto 6 sul telecomando
  { 
    digitalWrite(11, LOW);   // set the LED 0FF
  }
  if ( results.value == 0x0FF42BD ||  results.value == 0x10FF42BD ) //tasto 7 sul telecomando
  { 
    digitalWrite(9, HIGH);   // set the LED ON
  } 
 if ( results.value == 0xFF52AD ||  results.value == 0x10FF52AD ) //tasto 9 sul telecomando
  { 
    digitalWrite(9, LOW);   // set the LED 0FF   
  }  
}


